<template>
	<span class="time-control">
		<button-holder-control
			tabindex="-1"
			:disabled="leftDisabled"
			@click="decrement"
			@hold="decrement"
		>-</button-holder-control>
		<input
			type="text"
			:disabled="disabled"
			v-model="stringValue"
			@change="(e) => changeInputValue((e.target as HTMLInputElement).value)"
		/>
		<button-holder-control
			tabindex="-1"
			:disabled="rightDisabled"
			@click="increment"
			@hold="increment"
		>+</button-holder-control>
		<el-icon v-if="!disabled && resetable" title="reset" @click="handleReset">
			<Close />
		</el-icon>
	</span>
</template>

<script lang="ts" setup>

import { computed, PropType, ref, watch } from 'vue-demi';
import { ElIcon } from "element-plus";
import { Close } from "@element-plus/icons";
import { durationCompare, DurationTime, durationTotalHoursRounded, formatDuration, parseDurationFromHours } from '../../../lib/utils';
import ButtonHolderControl from "./ButtonHolderControl.vue";

const DELTA = 0.25;

type FormatType = "hours" | "time";

const props = defineProps({
	modelValue: Object as PropType<DurationTime | undefined>,
	format: {
		type: String as PropType<FormatType>,
		default: "hours",
	},
	resetable: {
		type: Boolean,
		default: true
	},
	disabled: {
		type: Boolean,
		default: false,
	},
	min: {
		type: Object as PropType<DurationTime>,
		default: () => DurationTime.zero(),
	},
	max: {
		type: Object as PropType<DurationTime>,
		default: () => DurationTime.create(24, 0),
	}
});

const emit = defineEmits<{
	(e: "update:modelValue", value: DurationTime): void,
	(e: "reset"): void,
}>();
const stringValue = ref('');
const hours = ref(0);

const min = computed(() => durationTotalHoursRounded(props.min));
const max = computed(() => durationTotalHoursRounded(props.max));
const leftDisabled = computed(() => props.disabled || min.value >= hours.value);
const rightDisabled = computed(() => props.disabled || max.value <= hours.value);

changeDuration(props.modelValue);

watch(() => props.modelValue, (val) => {
	changeDuration(val);
})

watch(() => props.format, (format) => {
	updateStringValue(hours.value, format);
})

function changeInputValue(val: string) {
	val = (val || '0').trim();

	if (/^\d+([,.]\d*)?$/.test(val)) { // 2.5 | 2 | 230
		const num = Number(val.replace(',', '.'));
		if (!/[,.]/.test(val) && num >= 100) {
			// nema desetinna mista a je vetsi nez 100
			// format 230 -> 2:30
			const hours = Math.floor(num / 100);
			const minutes = num % 100;
			changeValue(toHours(hours, minutes));
		} else { // 2.5 | 2 | 233.0
			changeValue(num);
		}
	} else if (/^\d+:\d\d$/.test(val)) { // 2:30 | 22:30 | 222:30
		const [hours, minutes] = val.split(':').map(Number);
		changeValue(toHours(hours, minutes));
	} else { // not valid input
		changeValue(hours.value);
	}
}

function increment() {
	changeValueAndRound(hours.value + DELTA, true);
}

function decrement() {
	changeValueAndRound(hours.value - DELTA, false);
}

function roundToMultiple(val: number, multiple: number) {
	const remainder = val % multiple;

	if (remainder === 0) {
		return val;
	}

	return val + multiple - remainder;
}

function toHours(hours: number, minutes: number) {
	return Number((hours + minutes / 60).toFixed(2));
}

function changeDuration(duration: DurationTime | undefined) {
	const hours = duration ? durationTotalHoursRounded(duration) : 0;
	changeValue(hours);
}

function changeValueAndRound(val: number, increase: boolean) {
	const delta = increase ? DELTA : -DELTA;
	val = roundToMultiple(val, delta);
	changeValue(val);
}

function handleReset() {
	emit("reset");
}

function changeValue(val: number) {
	if (val < min.value) {
		val = min.value;
	} else if (val > max.value || val >= 24) {
		val = 23.75;
	}

	const changed = hours.value !== val;

	hours.value = val;
	updateStringValue(val, props.format);

	if (changed) {
		emit('update:modelValue', parseDurationFromHours(val));
	}
}

function updateStringValue(hours: number, format: FormatType) {
	switch (format) {
		case "hours":
			stringValue.value = hours + '';
			break;

		case "time":
			stringValue.value = formatDuration(parseDurationFromHours(hours));
			break;
	}
}

</script>

<style lang="scss" scoped>
.time-control {
	display: flex;
	align-items: center;
}

input {
	width: 45px;
	text-align: center;
}

.el-icon {
	&:hover {
		cursor: pointer;
		color: red;
	}
}
</style>